scim::Property Class Reference
Accessories

Class to hold a property of a IMEngineInstance object or a Panel GUI client. More...

`#include <scim_property.h>`

## Public Member Functions

| Property ()
| Default constructor.
| Property (const String &key, const String &label, const String &icon=String(""), const String &tip=String(""))
| Constructor.
bool | valid () const
| Test if this property is valid.
bool | visible () const
| If this property is visible.
bool | active () const
| If this property is active.
const String & | get_key () const
| Get the key of this property.
const String & | get_label () const
| Get the label of this property.
const String & | get_icon () const
| Get the icon file of this property.
const String & | get_tip () const
| Get the tip of this property.
void | set_key (const String &key)
| Set a new key for this property.
void | set_label (const String &label)
| Set a new label for this property.
void | set_icon (const String &icon)
| Set a new icon file for this property.
void | set_tip (const String &tip)
| Set a new tip for this property.
void | set_active (bool active)
| Set if this property is active.
void | show (bool visible=true)
void | hide (bool hidden=true)
bool | is_a_leaf_of (const Property &node) const
| Test if this property is a leaf of another one.

## Detailed Description

Class to hold a property of a IMEngineInstance object or a Panel GUI client.

A property has four elements:

- key An unique identify key of the property, for example:
  - /TableInstance
  - /TableInstance/FullWidthLetter In this case, the second property will be a leaf (maybe a submenu item) of the first property.
- label A label of the property which should be displayed.
- icon An icon file of the property which should be displayed along with label.
- tip A string to descript what the property means.

With path like keys, the properties can form a cascade structure, which may be displayed like a cascading menu.

But only the leaf properties can act as trigger commands and give feedback to IMEngineInstance.

All strings should be encoded into UTF-8.

## Constructor & Destructor Documentation

## Property() [1/2]

scim::Property::Property | ( |  | ) |

inline

Default constructor.

Referenced by is_a_leaf_of().

## Property() [2/2]

scim::Property::Property | ( | const String & | key,
|  | const String & | label,
|  | const String & | icon = String (""),
|  | const String & | tip = String ("") )

inline

Constructor.

References SCIM_PROPERTY_ACTIVE, and SCIM_PROPERTY_VISIBLE.

## Member Function Documentation

## valid()

bool scim::Property::valid | ( |  | ) | const

inline

Test if this property is valid.

Returns
  true if this property is valid.

## visible()

bool scim::Property::visible | ( |  | ) | const

inline

If this property is visible.

Returns
  true if this property is visible.

References SCIM_PROPERTY_VISIBLE.

Referenced by show().

## active()

bool scim::Property::active | ( |  | ) | const

inline

If this property is active.

A active property can be clicked by users.

Returns
  true if this property is active.

References SCIM_PROPERTY_ACTIVE.

Referenced by set_active().

## get_key()

const String & scim::Property::get_key | ( |  | ) | const

inline

Get the key of this property.

Referenced by scim::operator!=(), scim::operator!=(), scim::operator!=(), scim::operator<(), scim::operator<(), scim::operator<(), scim::operator==(), scim::operator==(), and scim::operator==().

## get_label()

const String & scim::Property::get_label | ( |  | ) | const

inline

Get the label of this property.

## get_icon()

const String & scim::Property::get_icon | ( |  | ) | const

inline

Get the icon file of this property.

## get_tip()

const String & scim::Property::get_tip | ( |  | ) | const

inline

Get the tip of this property.

## set_key()

void scim::Property::set_key | ( | const String & | key | ) |

inline

Set a new key for this property.

## set_label()

void scim::Property::set_label | ( | const String & | label | ) |

inline

Set a new label for this property.

## set_icon()

void scim::Property::set_icon | ( | const String & | icon | ) |

inline

Set a new icon file for this property.

## set_tip()

void scim::Property::set_tip | ( | const String & | tip | ) |

inline

Set a new tip for this property.

## set_active()

void scim::Property::set_active | ( | bool | active | ) |

inline

Set if this property is active.

Parameters

  active | If this property is active.

References active(), and SCIM_PROPERTY_ACTIVE.

## show()

void scim::Property::show | ( | bool | visible = true | ) |

inline

References SCIM_PROPERTY_VISIBLE, and visible().

Referenced by hide().

## hide()

void scim::Property::hide | ( | bool | hidden = true | ) |

inline

References show().

## is_a_leaf_of()

bool scim::Property::is_a_leaf_of | ( | const Property & | node | ) | const

inline

Test if this property is a leaf of another one.

Returns
  true if this property is a leaf of the node.

References Property().

The documentation for this class was generated from the following file:

- scim_property.h